--- res_features.c.orig	2008-02-12 23:54:43.000000000 -0500
+++ res_features.c	2008-02-15 01:25:54.000000000 -0500
@@ -99,6 +99,7 @@
 
 static int transferdigittimeout;
 static int featuredigittimeout;
+static int comebacktoorigin = 1;
 
 static int atxfernoanswertimeout;
 
@@ -393,9 +394,13 @@
 	ast_mutex_unlock(&parking_lock);
 	/* Wake up the (presumably select()ing) thread */
 	pthread_kill(parking_thread, SIGURG);
-	if (option_verbose > 1) 
-		ast_verbose(VERBOSE_PREFIX_2 "Parked %s on %d@%s. Will timeout back to extension [%s] %s, %d in %d seconds\n", pu->chan->name, pu->parkingnum, parking_con, pu->context, pu->exten, pu->priority, (pu->parkingtime/1000));
-
+	if (option_verbose > 1) { 
+		if (comebacktoorigin) {
+			ast_verbose(VERBOSE_PREFIX_2 "Parked %s on %d@%s. Will timeout back to extension [%s] %s, %d in %d seconds\n", pu->chan->name, pu->parkingnum, parking_con, pu->context, pu->exten, pu->priority, (pu->parkingtime/1000));
+		} else {
+			 ast_verbose(VERBOSE_PREFIX_2 "Parked %s on %d@%s. Will timeout back to extension [parkedcallstimeout] s, 1 in %d seconds\n", pu->chan->name, pu->parkingnum, parking_con, (pu->parkingtime/1000));
+		}	
+	}
 	if (pu->parkingnum != -1)
 		snprintf(pu->parkingexten, sizeof(pu->parkingexten), "%d", x);
 	manager_event(EVENT_FLAG_CALL, "ParkedCall",
@@ -1634,6 +1639,7 @@
 	fd_set rfds, efds;	/* results from previous select, to be preserved across loops. */
 	FD_ZERO(&rfds);
 	FD_ZERO(&efds);
+	char parkingslot[5];
 
 	for (;;) {
 		struct parkeduser *pu, *pl, *pt = NULL;
@@ -1678,7 +1684,15 @@
 						snprintf(returnexten, sizeof(returnexten), "%s||t", peername);
 						ast_add_extension2(con, 1, peername, 1, NULL, NULL, "Dial", strdup(returnexten), ast_free, registrar);
 					}
-					set_c_e_p(chan, parking_con_dial, peername, 1);
+                                        if (comebacktoorigin) {
+	                                        set_c_e_p(chan, parking_con_dial, peername, 1);
+ 	                                } else {
+	                                        ast_log(LOG_WARNING, "now going to parkedcallstimeout,s,1 | ps is %d\n",pu->parkingnum);
+	                                        snprintf(parkingslot, sizeof(parkingslot), "%d", pu->parkingnum);
+	                                        pbx_builtin_setvar_helper(pu->chan, "PARKINGSLOT", parkingslot);
+	                                        set_c_e_p(chan, "parkedcallstimeout", "s", 1);
+                                        }
+
 				} else {
 					/* They've been waiting too long, send them back to where they came.  Theoretically they
 					   should have their original extensions and such, but we copy to be on the safe side */
@@ -2221,6 +2235,7 @@
 	parkfindnext = 0;
 	adsipark = 0;
 	parkaddhints = 0;
+	comebacktoorigin = 1;
 
 	transferdigittimeout = DEFAULT_TRANSFER_DIGIT_TIMEOUT;
 	featuredigittimeout = DEFAULT_FEATURE_DIGIT_TIMEOUT;
@@ -2289,6 +2304,8 @@
 			ast_copy_string(pickup_ext, var->value, sizeof(pickup_ext));
 		} else if (!strcasecmp(var->name, "parkedmusicclass")) {
 			ast_copy_string(parkmohclass, var->value, sizeof(parkmohclass));
+		}else if (!strcasecmp(var->name, "comebacktoorigin")) {
+			comebacktoorigin = ast_true(var->value);
 		}
 	}
 
